--
-- Beleuchtung v2.6
-- Specialization for additional lights
-- Spezialisierung fr Zusatzbeleuchtung
-- @author  Sven777b
-- 
-- frei verwendbar - keine erlaubnis ntig  |  free for use - no permission needed.
-- Modifikationen erst nach Rcksprache!    |  modifications only with my permission.
--
-- Hinweis: das kopieren von Sourcecode ist strafbar nach UrhG 2.1


LICHTADDON = {};

function LICHTADDON.prerequisitesPresent(specializations)
		print("specialization beleuchtung v2.6 by Sven777b");
    return true;
end;

function LICHTADDON:load(xmlFile)
		self.IClicht = {};
--Rundumleuchten
		self.IClicht["RUNDUMLEUCHTE"] = false;
		local i = 0;
		self.rundumleuchten = {};
    self.rundumleuchtenAn = false;
    self.rundumleuchtenprefix = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rundumleuchten#prefix"),"");
    self.rundumleuchtenStayOn = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.rundumleuchten#stayOn"),false);
		while true do
			local rul = {};
			local objname = string.format("vehicle.rundumleuchten.licht(%d)",i);
      local rotnode = getXMLString(xmlFile, objname .. "#rotNode");
      if rotnode == nil then break; end;
      rul = {};
      rul.rotNode = Utils.indexToObject(self.components, rotnode);
      rul.light = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#light"));
      if(rul.rotNode == nil or rul.light == nil) then
      	print("Error: Index ("..rotnode..") zur Rundumleuchte nicht gefunden");
      else
	      rul.speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
	      rul.source = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#lightsource"));
	      if (rul.source == nil) then
	      	rul.emit = false;
	      else
      		rul.emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
      		if not rul.emit then
      			setVisibility(rul.source, false);
      		end;
      	end;
      	table.insert(self.rundumleuchten, rul);
      end;
      i=i+1;
    end;
    self.rundumleuchtenAnz = table.getn(self.rundumleuchten);
--Arbeitslichter
    local i = 0;
    self.zusatzlampen = {};
    self.zusatzlampenprefix = Utils.getNoNil(getXMLString(xmlFile, "vehicle.zusatzlichter#prefix"),"");
    while true do
    	local objname = string.format("vehicle.zusatzlichter.licht(%d)",i);
    	local index = getXMLString(xmlFile, objname .. "#index");
    	if index == nil then break;	end;
    	local licht = {};
    	licht.index = Utils.indexToObject(self.components,index);
    	if licht.index == nil then
    		print("Error: Index ("..index..") zum Zusatzlicht "..i.." nicht gefunden");
    	else
    		licht.istAn = false;
    		setVisibility(licht.index, false);
    		licht.id = Utils.getNoNil(getXMLString(xmlFile, objname.."#id"),i);
    		licht.stayOn = Utils.getNoNil(getXMLString(xmlFile, objname.."#stayOn"),false);
    		table.insert(self.zusatzlampen, licht);
    		self.IClicht["ZUSATZLICHT"..licht.id] = false;
    	end;
    	i = i + 1;
    end;
    self.zusatzlampenAnz = table.getn(self.zusatzlampen);
--Positionslichter
		local i=0;
		self.poslichter = {};
		self.posstrobes = {};
		self.posdays = {};
		self.poslichterprefix = Utils.getNoNil(getXMLString(xmlFile, "vehicle.positionslichter#prefix"),"");
		self.poslichterAn = false;
		self.posdaysAn = false;
		while true do
			local objname = string.format("vehicle.positionslichter.licht(%d)",i);
			local index = getXMLString(xmlFile, objname.."#index");
			if index == nil then break; end;
			local licht = {};
			licht.index = Utils.indexToObject(self.components,index);
    	if licht.index == nil then
    		print("Error: Index ("..index..") zum Positionslicht "..i.." nicht gefunden");
    	else
    		setVisibility(licht.index, false);
    		licht.typ = Utils.getNoNil(getXMLString(xmlFile,objname.."#typ"),"perma");
    		if licht.typ == "strobe" then
    			licht.sequences = {Utils.getVectorFromString(Utils.getNoNil(getXMLString(xmlFile, objname.."#sequenz"),"1"))};
    			table.insert(self.posstrobes,licht);
    		elseif licht.typ == "daylight" then
    			table.insert(self.posdays,licht);
    		else
    			table.insert(self.poslichter,licht);
    		end;
    	end;
    	i=i+1;
    end;
    self.poslichterAnz = table.getn(self.poslichter);
    self.posstrobesAnz = table.getn(self.posstrobes);
    self.posdaysAnz = table.getn(self.posdays);
--Verstellungen
		local i=0;
		self.verstell = {};
		while true do
			local objname = string.format("vehicle.verstellungen.licht(%d)",i);
			local index = getXMLString(xmlFile, objname.."#index");
			if index == nil then break; end;
			local obj = {};
			obj.index = Utils.indexToObject(self.components,index);
			if obj.index == nil then
				print("Error: Index ("..index..") zum Licht "..i.." nicht gefunden");
			else
				obj.key1 = Input[getXMLString(xmlFile, objname.."#taste1")];
				if obj.key1 == nil then
					print("Error: taste1 fuer Verstellung "..i.." nicht gefunden"); break;
				end;
				obj.key2 = Input[getXMLString(xmlFile, objname.."#taste2")];
				if obj.key2 == nil then
					print("Error: taste2 fuer Verstellung "..i.." nicht gefunden"); break;
				end;
				obj.min = Utils.getNoNil(getXMLFloat(xmlFile, objname.."#min"),0);
				obj.max = Utils.getNoNil(getXMLFloat(xmlFile, objname.."#max"),0);
				obj.step = Utils.getNoNil(getXMLFloat(xmlFile, objname.."#step"),0.1);
				obj.axis = Utils.getNoNil(getXMLInt(xmlFile, objname.."#axis"),1);
				table.insert(self.verstell,obj);
			end;
			i=i+1;
		end;
		self.verstellAnz = table.getn(self.verstell);
--Fernlichschaltung
		local IndexAuf = getXMLString(xmlFile, "vehicle.fernlicht#aufblend");
		local IndexAb  = getXMLString(xmlFile, "vehicle.fernlicht#abblend");
		if IndexAuf ~= nil and IndexAb ~= nil then
			self.fernlicht = {};
			self.fernlicht.aufblend = Utils.indexToObject(self.components,IndexAuf);
			self.fernlicht.abblend  = Utils.indexToObject(self.components,IndexAb );
--			self.fernlicht.stayOn = Utils.getNoNil(getXMLBool(xmlFile,"vehicle.fernlicht#stayOn"),false);
			self.fernlicht.state = 0;
			self.IClicht["LICHT"] = false;
		end;
--Blinker
		local blinkerL = getXMLString(xmlFile, "vehicle.blinker#links");
		local blinkerR = getXMLString(xmlFile, "vehicle.blinker#rechts");
		if blinkerL ~= nil and blinkerR ~= nil then
			self.blinker = {};
			self.blinker.L = Utils.indexToObject(self.components, blinkerL);
			self.blinker.R = Utils.indexToObject(self.components, blinkerR);
			self.blinker.prefix = Utils.getNoNil(getXMLString(xmlFile,"vehicle.blinker#prefix"),"");
			self.blinker.stayOn = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.blinker#stayOn"),false);
			self.blinker.state = 0;
			self.blinker.timer = 0;
			self.IClicht["BLINKER_L"] = false;
			self.IClicht["BLINKER_R"] = false;
			self.IClicht["BLINKER_W"] = false;
		end;
--Bremslicht
		local bremslicht = getXMLString(xmlFile, "vehicle.bremslicht#index");
		if bremslicht ~= nil then
			self.bremslicht = Utils.indexToObject(self.components, bremslicht);
			self.brakesOn = false;
			self.isBraking = false;
		end;
--Rckfahr
		local revlicht = getXMLString(xmlFile, "vehicle.rueckfahrlicht#index");
		if revlicht ~= nil then
			self.revlicht = Utils.indexToObject(self.components, revlicht);
			self.revlichtAn = false;
		end;
		
--Helferlicht
		self.helferLichter = {};
		i=0;
		while true do
			local licht = {};
			local objname = string.format("vehicle.helfermodus.licht(%d)",i);
			local index = getXMLString(xmlFile, objname.."#index");
			if index == nil then break; end;
			licht.index = Utils.indexToObject(self.components, index);
			licht.state = Utils.getNoNil(getXMLBool(xmlFile, objname.."#ein"),false);
			table.insert(self.helferLichter,licht);
			i=i+1;
		end;
		self.nachtlicht = Utils.getNoNil(getXMLBool(xmlFile,"vehicle.helfermodus#nachtlicht"),false);
		self.nachtlichtAn = false;
		self.lichtStayOn = Utils.getNoNil(getXMLBool(xmlFile,"vehicle.lights#stayOn"),false);
		
--IC
		if SpecializationUtil.hasSpecialization(InteractiveButtons, self.specializations) then
			Button.doActionOrig = Button.doAction;
			Button.doAction = function(self,dt)
				self.vehicle.IClicht[self.event] = true;
				Button.doActionOrig(self,dt);
			end;
		end;

end;

function LICHTADDON:delete()
	if self.rundumleuchtenAnz > 0 then
		self.rundumleuchtenAn = false;
		for i=1,self.rundumleuchtenAnz do
			setVisibility(self.rundumleuchten[i].light, false);
		end;
	end;
	if self.zusatzlampenAnz > 0 then
		for i=1,self.zusatzlampenAnz do
			self.zusatzlampen[i].istAn = false;
			setVisibility(self.zusatzlampen[i].index , false);
		end;
	end;
	if self.blinker then
		if self.blinker.state > 0 then
			self.blinker.state = 0;
			setVisibility(self.blinker.L , false);
			setVisibility(self.blinker.R , false);
		end;
	end;
	if self.fernlicht then
		if self.fernlicht.state > 0 and not self.lightsActive then
			self.fernlicht.state = 0;
			setVisibility(self.fernlicht.aufblend , false);
			setVisibility(self.fernlicht.abblend  , false);
		end;
	end;
end;

function LICHTADDON:mouseEvent(posX, posY, isDown, isUp, button)
end;

function LICHTADDON:keyEvent(unicode, sym, modifier, isDown)
end;

function LICHTADDON:update(dt)
	if self:getIsActiveForInput() then
		--Rundumleuchten
		if self.rundumleuchtenAnz > 0 then
	    if InputBinding.hasEvent(InputBinding[self.rundumleuchtenprefix..'RUNDUMLEUCHTE']) or self.IClicht['RUNDUMLEUCHTE'] then
	    	self.rundumleuchtenAn = not self.rundumleuchtenAn;
	    	self.IClicht['RUNDUMLEUCHTE'] = false;
	    	-- syncronisieren mit Zugfahrzeug
	    	if self.attacherVehicle then
	    		if self.attacherVehicle.rundumleuchtenAnz ~= nil then
	    			self.rundumleuchtenAn = self.attacherVehicle.rundumleuchtenAn;
	    		end;
	    	end;
	      for i=1, self.rundumleuchtenAnz do
	        setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
	      end;
	    end;
	  end;
	  
	  --Zusatzlichter
	  if self.zusatzlampenAnz > 0 then
	  	for i=1, self.zusatzlampenAnz do
	  		local licht = self.zusatzlampen[i];
	  		if InputBinding.hasEvent(InputBinding[self.zusatzlampenprefix..'ZUSATZLICHT'..licht.id]) or self.IClicht['ZUSATZLICHT'..licht.id] then
	  			self.IClicht['ZUSATZLICHT'..licht.id] = false;
	  			licht.istAn = not licht.istAn;
	  			setVisibility(licht.index, licht.istAn);
	  		end;
	  	end;
	  end;
	  
	  --Positionslichter
	  if not self.poslichterAn then
	  	self.poslichterAn = true;
	  	if self.poslichterAnz > 0 then
				for i=1,self.poslichterAnz do
					setVisibility(self.poslichter[i].index,true);
				end;
			end;
		end;
		if self.lightsActive == self.posdaysAn then
			self.posdaysAn = not self.lightsActive;
			if self.posdaysAnz > 0 then
				for i=1,self.posdaysAnz do
					setVisibility(self.posdays[i].index, self.posdaysAn);
				end;
			end;
		end;
		--Verstellung
		if self.verstellAnz > 0 then
			for i=1,self.verstellAnz do 
				local v = self.verstell[i];
				local m = 0;
				if Input.isKeyPressed(v.key1) then
					m = math.rad(dt/1000*v.step);
				elseif Input.isKeyPressed(v.key2) then
					m = math.rad(-dt/1000*v.step);
				end;
				if m ~= 0 then
					local rot = {getRotation(v.index)};
					if (rot[v.axis]+m < math.rad(v.max)) and (rot[v.axis]+m > math.rad(v.min)) then
						local nrot = {0,0,0};
						nrot[v.axis] = m;
						rotate(v.index,unpack(nrot));
					end;
				end;
			end;
		end;
		--Fernlichtschaltung
		if self.fernlicht then
			if InputBinding.hasEvent(InputBinding.TOGGLE_LIGHTS) or self.IClicht['LICHT'] then
				self.IClicht['LICHT'] = false;
				self.fernlicht.state = self.fernlicht.state + 1;
				if self.fernlicht.state > 2 then self.fernlicht.state = 0; end;
				if self.fernlicht.state == 1 then
					self.lightsActive = true;
					self:setLightsVisibility(true);
					setVisibility(self.fernlicht.aufblend,false);
					setVisibility(self.fernlicht.abblend ,true);
				elseif self.fernlicht.state == 2 then
					self.lightsActive = true;
					self:setLightsVisibility(true);
					setVisibility(self.fernlicht.aufblend,true);
					setVisibility(self.fernlicht.abblend ,false);
				else
					self.lightsActive = false;
					self:setLightsVisibility(false);
					setVisibility(self.fernlicht.aufblend,false);
					setVisibility(self.fernlicht.abblend ,false);
				end;
			end;
		end;
		--Blinker schaltung
		if self.blinker then
			if InputBinding.hasEvent(InputBinding[self.blinker.prefix..'BLINKER_L']) or self.IClicht['BLINKER_L'] then
				self.IClicht['BLINKER_L'] = false;
				if self.blinker.state == 1 then self.blinker.state = 0; else self.blinker.state = 1; end;
			end;
			if InputBinding.hasEvent(InputBinding[self.blinker.prefix..'BLINKER_R']) or self.IClicht['BLINKER_R'] then
				self.IClicht['BLINKER_R'] = false;
				if self.blinker.state == 2 then self.blinker.state = 0; else self.blinker.state = 2; end;
			end;
			if InputBinding.hasEvent(InputBinding[self.blinker.prefix..'BLINKER_W']) or self.IClicht['BLINKER_W'] then
				self.IClicht['BLINKER_W'] = false;
				if self.blinker.state == 3 then self.blinker.state = 0; else self.blinker.state = 3; end;
			end;
			-- syncronisieren mit Zugfahrzeug
			if self.attacherVehicle then
				if self.attacherVehicle.blinker then
					self.blinker.state = self.attacherVehicle.blinker.state;
				end;
			end;
		end;
		--Bremslicht
		if self.bremslicht ~= nil then
			local acceleration = 0;
      acceleration = -InputBinding.getAnalogInputAxis(InputBinding.AXIS_FORWARD);
      if InputBinding.isAxisZero(acceleration) then
          acceleration = -InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);
      end;
      if acceleration * self.movingDirection < 0 then
      	self.isBraking = true;
      else
      	self.isBraking = false;
      end;
    end;
	end;

  if self:getIsActive() then
		--Strobes
		if self.posstrobesAnz > 0 then
			for i=1,self.posstrobesAnz do
				local licht = self.posstrobes[i];
				if licht.nextseq == nil then licht.nextseq = 1; end;
				if licht.seqtimer == nil then licht.seqtimer = 0; end;
				if licht.seqtimer > licht.sequences[licht.nextseq] then
					local status = getVisibility(licht.index);
					setVisibility(licht.index , not status);
					licht.seqtimer = 0;
					licht.nextseq = licht.nextseq+1;
					if licht.nextseq > table.getn(licht.sequences) then
						licht.nextseq = 1;
					end;
				else
					licht.seqtimer = licht.seqtimer + (dt/1000);
				end;
			end;
		end;

		--AI
		if self.isAITractorActivated then
			if self.nachtlicht then
		    if self.nachtlichtAn ~= g_currentMission.environment.isSunOn then
						self.lightsActive = self.nachtlichtAn;
						self:setLightsVisibility(self.nachtlichtAn);
		        self.nachtlichtAn = g_currentMission.environment.isSunOn;
		    end;
		  end;
			
			if self.turnStage == 1 then
				if not self.isBraking then 
					self.isBraking = true;
					if self.blinker then self.blinker.state = 3; end;
				end;
			else
				if self.isBraking then
					self.isBraking = false;
				end;
			end;
			if self.turnStage == 0 then
				if self.blinker.state == 3 then
					if self.blinker then self.blinker.state = 0; end;
				end;
			end;
		end;

		--Bremslicht
		if self.bremslicht then
			if self.isBraking ~= self.brakesOn then
				setVisibility(self.bremslicht, self.isBraking);
				self.brakesOn = self.isBraking;
			end;
		end;

    --Rckfahrlicht
    if self.revlicht then
    	if self.movingDirection < 0 then
    		if not self.revlichtAn then
	    		setVisibility(self.revlicht, true);
	    		self.revlichtAn = true;
	    	end;
	    else
	    	if self.revlichtAn then
	    		setVisibility(self.revlicht, false);
	    		self.revlichtAn = false;
	    	end;
	    end;
	  end;
	end;

	--perma an
  if self.rundumleuchtenAn then
    for i=1, self.rundumleuchtenAnz do
      rotate(self.rundumleuchten[i].rotNode, 0, dt*self.rundumleuchten[i].speed, 0);
    end;
  end;

	--Blinker
	if self.blinker then
		if self.blinker.state > 0 then
			self.blinker.timer = self.blinker.timer + dt;
			if self.blinker.timer > 750 then
				if self.blinker.state == 1 then
					setVisibility(self.blinker.L, not getVisibility(self.blinker.L));
				elseif self.blinker.state == 2 then
					setVisibility(self.blinker.R, not getVisibility(self.blinker.R));
				else
					local state = not getVisibility(self.blinker.L);
					setVisibility(self.blinker.L, state);
					setVisibility(self.blinker.R, state);
				end;
				self.blinker.timer = 0;
			end;
		elseif self.blinker.timer ~= 0 then
			setVisibility(self.blinker.L, false);
			setVisibility(self.blinker.R, false);
			self.blinker.timer = 0;
		end;
	end;
end;

function LICHTADDON:draw()
    if self.rundumleuchtenAnz > 0 and self:getIsActive() then
    	if string.sub(g_i18n:getText(self.rundumleuchtenprefix.."rundumleuchte"),0,7) ~= "Missing" then
    		g_currentMission:addHelpButtonText(g_i18n:getText(self.rundumleuchtenprefix.."rundumleuchte"), InputBinding[self.rundumleuchtenprefix..'RUNDUMLEUCHTE']);
    	end;
    end;
    if self.zusatzlampenAnz > 0 and self:getIsActive() then
    		for i=1, self.zusatzlampenAnz do
    			if string.sub(g_i18n:getText(self.zusatzlampenprefix.."zusatzlicht"..self.zusatzlampen[i].id),0,7) ~= "Missing" then
    				g_currentMission:addHelpButtonText(g_i18n:getText(self.zusatzlampenprefix.."zusatzlicht"..self.zusatzlampen[i].id), InputBinding[self.zusatzlampenprefix..'ZUSATZLICHT'..self.zusatzlampen[i].id]);
    			end;
    		end;
    end;

end;

function LICHTADDON:onLeave()
	if self.rundumleuchtenAnz > 0 then
		if not self.rundumleuchtenStayOn then
			self.rundumleuchtenAn = false;
			for i=1,self.rundumleuchtenAnz do
				setVisibility(self.rundumleuchten[i].light, false);
			end;
		end;
	end;
	if self.zusatzlampenAnz > 0 then
		for i=1,self.zusatzlampenAnz do
			if not self.zusatzlampen[i].stayOn then
				self.zusatzlampen[i].istAn = false;
				setVisibility(self.zusatzlampen[i].index , false);
			end;
		end;
	end;
	if self.poslichterAn and self.poslichterAnz > 0 then
		self.poslichterAn = false;
		for i=1,self.poslichterAnz do
			setVisibility(self.poslichter[i].index,false);
		end;
	end;
	if self.posstrobesAnz > 0 then
		for i=1,self.posstrobesAnz do
			self.posstrobes[i].seqtimer = 0;
			self.posstrobes[i].nextseq = 1;
			setVisibility(self.posstrobes[i].index, false);
		end;
	end;
	if self.posdaysAn and self.posdaysAnz > 0 then
		self.posdaysAn = false;
		for i=1,self.posdaysAnz do
			setVisibility(self.posdays[i].index,false);
		end;
	end;
	for k,v in pairs(self.helferLichter) do
		setVisibility(v.index,v.state);
	end;
	if self.lichtStayOn then
		if self.fernlicht then
			if self.fernlicht.state > 0 then
				if self.fernlicht.state == 1 then
					self.lightsActive = true;
					self:setLightsVisibility(true);
					setVisibility(self.fernlicht.aufblend,false);
				else
					self.lightsActive = true;
					self:setLightsVisibility(true);
					setVisibility(self.fernlicht.aufblend,true);
				end;
			else
				self.lightsActive = false;
				self:setLightsVisibility(false);
				setVisibility(self.fernlicht.aufblend,false);
			end;
		else
			self.lightsActive = true;
			self:setLightsVisibility(true);
		end;
	end;
end;

function LICHTADDON:onEnter()
	for k,v in pairs(self.helferLichter) do
		setVisibility(v.index, not v.state);
	end;
end;

